EDIT - bug #8754

DescriptionElements are not deleted with the Descriptive Data Set
12/06/2019 10:04 PM - Andreas Kohlbecker

Status: Resolved Start date:

Priority: New Due date:

Assignee: Andreas Muller % Done: 30%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.15

Severity: normal Found in Version:

Description

Based on the dump and situation in #8752:
o deleted both descriptive datasets
¢ delete the Character trees (for problems during this step see the ticket from which this one has been copied #8753)
e try to delete a Character term

This fails since the terms are still being used in description elements (QuatitativeData in case of bract length)

Related issues:

Blocked by EDIT - bug #9053: CCE when selecting Character Tree for descriptiv... Closed
Copied from EDIT - bug #8753: EagerLoadingException on opening Character Tree... Closed
Copied from EDIT - feature request #9084: Make it configurable if a Descripti... Resolved

Associated revisions

Revision af46e1a1 - 05/05/2020 10:26 AM - Katja Luther

ref #8754: implement delete method for descriptiveDataSet

Revision e423ad05 - 06/17/2020 12:22 PM - Katja Luther
ref #8754: add deleteConfig for descriptiveDataset

Revision 08a36bdf - 06/17/2020 12:26 PM - Katja Luther
ref #8754: adapt deleteHandling to configuration

Revision 97a2bbb9 - 06/20/2020 12:59 AM - Katja Luther

ref #8754: adapt description for delete descriptions

History

#1 - 12/06/2019 10:04 PM - Andreas Kohlbecker
- Copied from bug #8753: EagerlLoadingException on opening Character Tree Editor after deleting all Desciptive Data Sets added

#2 - 12/06/2019 10:05 PM - Andreas Kohlbecker
- Description updated

#3 - 01/16/2020 01:00 PM - Katja Luther

- Target version changed from Release 5.12 to Release 5.13

#4 - 03/09/2020 04:30 PM - Andreas Miiller

- Target version changed from Release 5.13 to Release 5.14

#5 - 04/08/2020 03:49 PM - Andreas Miiller

- Target version changed from Release 5.14 to Release 5.15

#6 - 05/04/2020 05:08 PM - Katja Luther

Deleting the descriptive dataset calls the delete method of IdentifiableServiceBase, but should be an extra delete method to handle the deletion of the
descriptions.

#7 - 05/05/2020 10:31 AM - Katja Luther
- Status changed from New to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

A new method for deletion of descriptive datasets are implemented, which uses DescriptionService.deleteDescription() for the deletion of descriptions
and when the description is deleted, the description elements are deleted by cascading.

please review.

#8 - 05/05/2020 03:13 PM - Katja Luther

- Status changed from Resolved to In Progress

the deletion of larger datasets takes some time, therefore it is implemented as a long running task now. Need to test, so | take the ticket back to me.

#9 - 05/05/2020 03:13 PM - Katja Luther

- Assignee changed from Andreas Muiller to Katja Luther

#10 - 05/26/2020 10:21 AM - Katja Luther
- Status changed from In Progress to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

please review.

#11 - 06/04/2020 08:37 AM - Andreas Miiller

- Description updated

#12 - 06/04/2020 08:37 AM - Andreas Miiller

- Description updated

#13 - 06/04/2020 08:50 AM - Andreas Miiller
- Blocked by bug #9053: CCE when selecting Character Tree for descriptive dataset added

#14 - 06/04/2020 09:32 AM - Andreas Miiller

When trying to delete a descriptive dataset | got the following exception. Though it seems as if the delete was executed (data did not exist anymore).

last remote method : http://test.e-taxonomy.eu:80/cdmserver/rem_conf_am/remoting/progressmonitor.service
last remote request client time : 2020-06-04T09:28:55.063
last remote request response header time : Thu, 04 Jun 2020 09:28:55 GMT
client error time : 2020-06-04T09:28:55.11
login : admin
editor version : 5.15.0.202006032253
server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 5.15.0.0.20200510
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_121
org.springframework.dao.InvalidDataAccessResourceUsageException: could not execute statement; SQL [n/a]; neste
d exception is org.hibernate.exception.SQLGrammarException: could not execute statement

at org.springframework.orm.hibernate5.SessionFactoryUtils.convertHibernateAccessException (SessionFactoryUt
ils.java:147)

at org.springframework.orm.hibernate5.HibernateTransactionManager.convertHibernateAccessException (Hibernat
eTransactionManager. java:741)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (HibernateTransactionManager. jav
a:589)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.processCommit (AbstractPlatfo
rmTransactionManager. java:761)

at org.springframework.transaction.support.AbstractPlatformTransactionManager.commit (AbstractPlatformTrans
actionManager. java:730)

at org.springframework.transaction.interceptor.TransactionAspectSupport.commitTransactionAfterReturning (Tr
ansactionAspectSupport.java:485)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction (Transactio
nAspectSupport.java:291)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterceptor. java:9
at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17

9)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.$Proxy649.delete (Unknown Source)

at eu.etaxonomy.cdm.api.service.longrunningService.LongRunningTasksService$5.doRun (LongRunningTasksService
.java:155)

at eu.etaxonomy.cdm.common.monitor.RemotingProgressMonitorThread.run (RemotingProgressMonitorThread. java:42
)
Caused by: org.hibernate.exception.SQLGrammarException: could not execute statement

at org.hibernate.exception.internal.SQLStateConversionDelegate.convert (SQLStateConversionDelegate. java:106

at org.hibernate.exception.internal.StandardSQLExceptionConverter.convert (StandardSQLExceptionConverter. ja
va:42)

at org.hibernate.engine. jdbc.spi.SglExceptionHelper.convert (SglExceptionHelper.java:109)

at org.hibernate.engine. jdbc.spi.SglExceptionHelper.convert (SglExceptionHelper. java:95)

at org.hibernate.engine. jdbc.internal.ResultSetReturnImpl.executeUpdate (ResultSetReturnImpl. java:207)

at org.hibernate.engine. jdbc.batch.internal.NonBatchingBatch.addToBatch (NonBatchingBatch. java:45)

at org.hibernate.persister.entity.AbstractEntityPersister.insert (AbstractEntityPersister. java:2886)

at org.hibernate.persister.entity.AbstractEntityPersister.insert (AbstractEntityPersister.java:3386)

at org.hibernate.action.internal.EntityInsertAction.execute (EntityInsertAction.java:89)

at org.hibernate.engine.spi.ActionQueue.executeActions (ActionQueue. java:560)

at org.hibernate.engine.spi.ActionQueue.executeActions (ActionQueue. java:434)

at org.hibernate.event.internal.AbstractFlushingEventListener.performExecutions (AbstractFlushingEventListe
ner.java:337)

at org.hibernate.event.internal.DefaultFlushEventListener.onFlush (DefaultFlushEventListener. java:39)

at org.hibernate.internal.SessionImpl.flush(SessionImpl.java:1282)

at org.hibernate.envers.internal.synchronization.AuditProcess.doBeforeTransactionCompletion (AuditProcess.j
ava:156)

at org.hibernate.envers.internal.synchronization.AuditProcessManager$l.doBeforeTransactionCompletion (Audit
ProcessManager. java:46)

at org.hibernate.engine.spi.ActionQueue$BeforeTransactionCompletionProcessQueue.beforeTransactionCompletio
n (ActionQueue. java:899)

at org.hibernate.engine.spi.ActionQueue.beforeTransactionCompletion (ActionQueue. java:481)

at org.hibernate.internal.SessionImpl.beforeTransactionCompletion (SessionImpl. java:2340)

at org.hibernate.engine. jdbc.internal.JdbcCoordinatorImpl.beforeTransactionCompletion (JdbcCoordinatorImpl.
java:485)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourceLocalTransactionCoordinatorImpl.be
foreCompletionCallback (JdbcResourcelLocalTransactionCoordinatorImpl. java:147)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelocalTransactionCoordinatorImpl.ac
cess$100 (JdbcResourcelocalTransactionCoordinatorImpl. java:38)

at org.hibernate.resource.transaction.backend. jdbc.internal.JdbcResourcelLocalTransactionCoordinatorImpls$Tr
ansactionDriverControlImpl.commit (JdbcResourcelLocalTransactionCoordinatorImpl. java:231)

at org.hibernate.engine.transaction.internal.TransactionImpl.commit (TransactionImpl. java:65)

at org.springframework.orm.hibernate5.HibernateTransactionManager.doCommit (HibernateTransactionManager.jav
a:581)

... 10 more
Caused by: java.sgl.SQLException: No value specified for parameter 6

at com.mysgl.cj.jdbc.exceptions.SQLError.createSQLException (SQLError. java:129)

at com.mysqgl.cj.jdbc.exceptions.SQLError.createSQLException (SQLError. java:97)

at com.mysgl.cj.jdbc.exceptions.SQLExceptionsMapping.translateException (SQLExceptionsMapping. java:122)

at com.mysqgl.cj.jdbc.ClientPreparedStatement.executeUpdateInternal (ClientPreparedStatement. java:1132)

at com.mysqgl.cj.jdbc.ClientPreparedStatement.executeUpdateInternal (ClientPreparedStatement. java:1057)

at com.mysgl.cj.jdbc.ClientPreparedStatement.executelargeUpdate (ClientPreparedStatement.java:1377)

at com.mysqgl.cj.jdbc.ClientPreparedStatement.executeUpdate (ClientPreparedStatement. java:1042)

at com.mchange.v2.c3p0.impl.NewProxyPreparedStatement.executeUpdate (NewProxyPreparedStatement. java:384)

at org.hibernate.engine. jdbc.internal.ResultSetReturnImpl.executeUpdate (ResultSetReturnImpl.java:204)

30 more

#15 - 06/04/2020 09:54 AM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Muiller to Katja Luther

- % Done changed from 0 to 20

Generally | have problems to understand this ticket.

Do | understand it correctly that the expectation is that deleting the DDS will also delete all specimen and taxon descriptions including their description
elements?

This is critical because descriptions are not primarily related to DDSs but to their specimen or taxon. So only deleting the specimen or the taxon is
expected to automatically delete the description.
When deleting a DDS we need a configurator asking if 1) all specimen descriptions should not only be removed from the DDS but also be deleted
completely, 2) all "literature" descriptions should be deleted completely, 3) all "default" descriptions should be deleted completely, 4) all aggregated
descriptions should be deleted completely (and maybe in future 5. all keys should be deleted completely).

For 4) this is the expected behavior but for all others it is not necessarily the case.

This issue is maybe currently not yet so clear because at the moment it is not yet possible to use existing descriptions for a DDS. But this should be
possible in future especially to make it possible to reuse import result but also in other contexts.

#16 - 06/16/2020 11:16 AM - Andreas Miiller
Andreas Miller wrote:
Generally | have problems to understand this ticket.

Do | understand it correctly that the expectation is that deleting the DDS will also delete all specimen and taxon descriptions including their
description elements?

This is critical because descriptions are not primarily related to DDSs but to their specimen or taxon. So only deleting the specimen or the taxon
is expected to automatically delete the description.

When deleting a DDS we need a configurator asking if 1) all specimen descriptions should not only removed from the DDS but also deleted
completely, 2) all "literature" descriptions should be deleted completely, 3) all "default” descriptions should be deleted completely, 4) all
aggregated descriptions should be deleted completely (and maybe in future 5. all keys should be deleted completely).

For 4) this is the expected behavior but for all others it is not necessarily the case.

This issue is maybe currently not yet so clear because at the moment it is not yet possible to use existing descriptions for a DDS. But this should

be possible in future especially to make it possible to reuse import result but also in other contexts.

Katja, Andreas K., can you please have a look on my comment?
#17 - 06/16/2020 11:17 AM - Katja Luther
Andreas Muller wrote:
Andreas Miiller wrote:
Generally | have problems to understand this ticket.

Do | understand it correctly that the expectation is that deleting the DDS will also delete all specimen and taxon descriptions including their
description elements?

This is critical because descriptions are not primarily related to DDSs but to their specimen or taxon. So only deleting the specimen or the
taxon is expected to automatically delete the description.

When deleting a DDS we need a configurator asking if 1) all specimen descriptions should not only removed from the DDS but also deleted
completely, 2) all "literature" descriptions should be deleted completely, 3) all "default" descriptions should be deleted completely, 4) all
aggregated descriptions should be deleted completely (and maybe in future 5. all keys should be deleted completely).

For 4) this is the expected behavior but for all others it is not necessarily the case.

This issue is maybe currently not yet so clear because at the moment it is not yet possible to use existing descriptions for a DDS. But this
should be possible in future especially to make it possible to reuse import result but also in other contexts.

Katja, Andreas K., can you please have a look on my comment?

I think you are right and | implement the delete method right now with a configurator.
#18 - 06/16/2020 02:14 PM - Andreas Kohlbecker
| don't exactly remember the situation out of which | wrote this tickt, but from my current point of view the solution suggested by you Andreas and

implemented by Katja seems to be the correct way to transparently handle this.

#19 - 06/18/2020 09:02 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

now the configuration is available. please review
#20 - 06/19/2020 03:57 PM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Muiller to Katja Luther

Katja Luther wrote:

now the configuration is available. please review

Something still is wrong here. What | did:
Use AM_test_dataset in rem_conf_am and look at Nepenthes morganiana.

e At beginning 2 specimen descriptions were there for specimens "Germany, outside" and "no information" (which is a pure Derived Unit without
FieldUnit)

¢ when selecting delete, no delete warning with configuration possibilities appears but only the record is deleted from the matrix without warning.
Sometimes even both records were deleted though the focus was only at 1 of them; | expected exactly 1 record to be deleted and a dialog with
"do you really want ..." and with the possibility to configure if the record should be delete from the specimen, too.

#21 - 06/19/2020 04:14 PM - Katja Luther
Andreas Muller wrote:
Katja Luther wrote:

now the configuration is available. please review

Something still is wrong here. What | did:
Use AM_test_dataset in rem_conf_am and look at Nepenthes morganiana.

e At beginning 2 specimen descriptions were there for specimens "Germany, outside" and "no information" (which is a pure Derived Unit
without FieldUnit)

¢ when selecting delete, no delete warning with configuration possibilities appears but only the record is deleted from the matrix without
warning. Sometimes even both records were deleted though the focus was only at 1 of them; | expected exactly 1 record to be deleted and
a dialog with "do you really want ..." and with the possibility to configure if the record should be delete from the specimen, too.

Did you try to delete the descriptive dataset? This is what the ticket is about.
For removing descriptions from the matrix there is the ticket #8785.

#22 - 06/19/2020 04:38 PM - Andreas Miiller
- % Done changed from 20 to 30

#23 - 06/19/2020 04:40 PM - Andreas Miiller

Katja Luther wrote:

Andreas Muller wrote:
Katja Luther wrote:

now the configuration is available. please review

Something still is wrong here. What | did:
Use AM_test_dataset in rem_conf_am and look at Nepenthes morganiana.

e At beginning 2 specimen descriptions were there for specimens "Germany, outside" and "no information" (which is a pure Derived Unit
without FieldUnit)

¢ when selecting delete, no delete warning with configuration possibilities appears but only the record is deleted from the matrix without
warning. Sometimes even both records were deleted though the focus was only at 1 of them; | expected exactly 1 record to be deleted
and a dialog with "do you really want ..." and with the possibility to configure if the record should be delete from the specimen, too.

Did you try to delete the descriptive dataset? This is what the ticket is about.
For removing descriptions from the matrix there is the ticket #8785.

Upps, sorry, yes you are right. | was mixing things up here.

#24 - 06/19/2020 04:49 PM - Katja Luther

Andreas Muller wrote:

There is also another strange behavior. When | do "reattache" the specimen to the matrix the old record seems to be reattached (which might be
a good idea but needs to be discussed for details). But the problem seems to be that if in the meanwhile the record has been changed this seem
not be reflected in the Ul or in the record itself. It looks like the old version is somewhere cached and attached as it was instead of reloading it
from the DB.

... hmm, | tested now for a relatively long time with Matrix Editor open and deleting and reattaching Specimen Descriptions and at the same time
the Specimen Tree Editor was open and sometimes | edited data there sometimes | only used it for checking referencing objects and ids. |
sometimes only closed these editor sometimes closed the TaxEditor application and restartet. | was working on rem_conf_am / Am test dataset
with specimen attached to Nepenthes morganiana.

However the behavior to me seems mostly unpredictable. Sometimes specimen descriptions are removed from the matrix which | did never
remove. Sometimes other descriptions reappear after restart though | had deleted them. Sometimes measurement values that were deleted in
Specimen Tree Editor reappear after reattaching a specimen to the matrix, ... | am a bit confused how to describe this because nothing is really
reproducable but very often does not work as expected.

The main issue | originally wanted to test was how the deleting and adding of specimens in the matrix reacts if a possible SpecimenDescription
candidate already exists. Is this reused or there always a new record created, or something else. But | couldn't really find.

However, for such a case we probably need some warning saying: there is a specimen description available already, do you want to use it? Also
for imports this might be needed.

But first of all, could you please test if you can reproduce the above strange behvior (with my data or with other data)?

| could not test it, yet, but maybe this is a problem of synchronisation between the two editors. | will have a look.

#25 - 06/19/2020 04:57 PM - Andreas Miiller

Katja Luther wrote:

| could not test it, yet, but maybe this is a problem of synchronisation between the two editors. | will have a look.

OK, thank. Of course this issue also belongs more to #8785 then to this ticket. | mixed up these 2 tickets. | will move my comments to the other ticket
or link from there to here.

#26 - 06/19/2020 05:12 PM - Andreas Miiller
- File picture499-1.png added

So back to original issue of this ticket.

The configurator now looks like
& ED Confirm delete

Do you really want to delete the descriptive data set?

~ Configure
[+ Specimen descriptions
[/] Default descriptions
Literature descriptions
[¥] Aggregated descriptions

[

so the user does not know what the configuration is for.
Please change the labels and explanations in a way that it becomes clear what the expected result is.

E.g. Fully delete the following related descriptions (unchecked descriptions stay in the database attached to their taxa/specimens):

#27 - 06/19/2020 05:33 PM - Andreas Miiller
| moved #note-22 to #8785 as it belongs to this ticket (I added it accidentely here)

#28 - 06/19/2020 06:51 PM - Andreas Miiller
- File picture985-1.png added
- File picture985-2.png added
- File picture985-3.png added

| watched another strange behavior about the selected taxon. | created a new DDS in rem_conf_am and added the taxon node for "Danthella test
Node" which is a grand-child of Facchinia:

[- 1est new tree editor
4 Tes
Test
I Arenaria Adans,
4 Facchinia Rchb.
4 Facchinia
4 antAella Clauson & Pomel
4 Dianthella test Node
Test homotypic Synor

In the DDS editor this shows up correctly:

l Taxon filter

‘ 4 Dianthella test Node
‘ Test homotypic Synenym

But in the matrix the whole tree up to Facchinia is shown:

Unit

4 Facchinia Rchb.
PR——
4 Facchinia
4 Dianthella Clauson & P
4 Dianthella test Mode

For—

L

#29 - 06/19/2020 06:54 PM - Katja Luther

Andreas Muller wrote:

| watched another strange behavior about the selected taxon. | created a new DDS in rem_conf_am and added the taxon node for "Danthella
test Node" which is a grand-child of Facchinia:
[+ 1est new tree editor
a Tes
Test
I Arenaria Adans.
4 Facchinia Rchb.
4 Facchinia

‘:ﬁﬁﬁfﬁella Clauson & Pomel

4 Dianthella test Node
Test homotypic Synor

In the DDS editor this shows up correctly:

l Taxon filter

‘ 4 Dianthella test Node
‘ Test hemotypic Synenym

But in the matrix the whole tree up to Facchinia is shown:

Unit

4 Facchinia Rchb.
——
4 Facchinia
4 Dianthella Clauson & P
4 Dianthella test Mode

fFor—

(ST

This depends on the rank defined in the descriptive dataset. If you do not define a max rank, the whole tree is shown.
#30 - 06/19/2020 07:25 PM - Andreas Miiller
Katja Luther wrote:

This depends on the rank defined in the descriptive dataset. If you do not define a max rank, the whole tree is shown.
Upps, you are right. But | wonder if this makes sense? We need to discuss this with users (Norbert). Maybe there was a discussion on this during
additivity, | somehow remember, so we may have a look to the wiki. To me it doesn't sound reasonable. If a subtree filter is defined why should we
also want to show the higher taxa? Maybe the common parent for a set of subtrees still makes sense.

Hmm, maybe it was for the default descriptions to be able to add default descriptions on a higher level.
This needs to be discussed but it is definetly a new ticket as this is not a regression (it was like this before).

#31 - 06/20/2020 12:57 AM - Katja Luther
Andreas Miller wrote:
So back to original issue of this ticket.

The configurator now looks like

Confirm delete

Do you really want to delete the descriptive data set?

= Configure
[w] Specimen descriptions
[+/] Default descriptions
Literature descriptions
[+] Aggregated descriptions

[

so the user does not know what the configuration is for.
Please change the labels and explanations in a way that it becomes clear what the expected result is.

E.g. Fully delete the following related descriptions (unchecked descriptions stay in the database attached to their taxa/specimens):
The description of the dialog is adapted.

#32 - 06/22/2020 09:40 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller

#33 - 06/22/2020 10:00 AM - Andreas Miuiller

- Status changed from Feedback to Resolved

#34 - 06/22/2020 04:24 PM - Katja Luther

Katja Luther wrote:

Andreas Muller wrote:

There is also another strange behavior. When | do "reattache" the specimen to the matrix the old record seems to be reattached (which
might be a good idea but needs to be discussed for details). But the problem seems to be that if in the meanwhile the record has been
changed this seem not be reflected in the Ul or in the record itself. It looks like the old version is somewhere cached and attached as it was
instead of reloading it from the DB.

... hmm, | tested now for a relatively long time with Matrix Editor open and deleting and reattaching Specimen Descriptions and at the same
time the Specimen Tree Editor was open and sometimes | edited data there sometimes | only used it for checking referencing objects and
ids. | sometimes only closed these editor sometimes closed the TaxEditor application and restartet. | was working on rem_conf_am / Am
test dataset with specimen attached to Nepenthes morganiana.

However the behavior to me seems mostly unpredictable. Sometimes specimen descriptions are removed from the matrix which | did never
remove. Sometimes other descriptions reappear after restart though | had deleted them. Sometimes measurement values that were deleted
in Specimen Tree Editor reappear after reattaching a specimen to the matrix, ... | am a bit confused how to describe this because nothing is
really reproducable but very often does not work as expected.

The main issue | originally wanted to test was how the deleting and adding of specimens in the matrix reacts if a possible
SpecimenDescription candidate already exists. Is this reused or there always a new record created, or something else. But | couldn't really
find.

However, for such a case we probably need some warning saying: there is a specimen description available already, do you want to use it?
Also for imports this might be needed.

But first of all, could you please test if you can reproduce the above strange behvior (with my data or with other data)?

| could not test it, yet, but maybe this is a problem of synchronisation between the two editors. | will have a look.

this is fixed.

#35 - 09/21/2021 11:34 AM - Andreas Miiller

- Copied from feature request #9084: Make it configurable if a Description is deleted only from the Descriptive Data Set or from it's Specimen/Taxon

added
Files
